from pickletools import int4
from tokenize import Double
import pandas as pd
import soundfile as sf
import numpy as np
import struct
import wave
import math
file_to_read = 'Measuring_29-04_14-54-35.csv'
#file_to_read = 'sine_signal_as_CSV.csv'
channel_to_read = 'Channel1'
df = pd.read_csv(file_to_read, sep=';', usecols=['Name',channel_to_read], skiprows= [1,2,3,4,5,6,7,8,9])

fname="waveOuput.wav"
# compute sample rate, assuming times are in seconds

frate = 11025.0  # framerate as a float
amp = 8000.0     # multiplier for amplitude

times = df['Name'].values

# write data
data = df[channel_to_read].values
nframes = len(data)
 # get ready for the wave file to be saved ...
wav_file = wave.open(fname, "w")
# give required parameters
nchannels = 1
sampwidth = 2
framerate = int(frate)

comptype = "NONE"
compname = "not compressed"
# set all the parameters at once
wav_file.setparams((nchannels, sampwidth, framerate, nframes, comptype, compname))
# now write out the file ...
print( "creating wave file ..." )
for s in data:
    if(math.isnan(s)):
        print('s in nan')
    else:
        wav_file.writeframes(struct.pack('i', int(s*amp/2)))
wav_file.close()
print( "%s written" % fname )
